Исключение ошибки Catch Firebase 503 не перехватило мою инструкцию try

Я использую прослушиватель базы данных Firebase Realtime для прослушивания изменений в пути к базе данных.

Моя программа недавно разбилась из-за следующей ошибки 503, которая, по-видимому, вызвана базовой библиотекой requests:

Traceback (most recent call last):
  File "/usr/local/lib/python3.7/threading.py", line 917, in _bootstrap_inner
    self.run()
  File "/usr/local/lib/python3.7/threading.py", line 865, in run
    self._target(*self._args, **self._kwargs)
  File "/usr/local/lib/python3.7/site-packages/firebase_admin/db.py", line 123, in _start_listen
    for sse_event in self._sse:
  File "/usr/local/lib/python3.7/site-packages/firebase_admin/_sseclient.py", line 128, in __next__
    self._connect()
  File "/usr/local/lib/python3.7/site-packages/firebase_admin/_sseclient.py", line 112, in _connect
    self.resp.raise_for_status()
  File "/usr/local/lib/python3.7/site-packages/requests/models.py", line 940, in raise_for_status
    raise HTTPError(http_error_msg, response=self)
requests.exceptions.HTTPError: 503 Server Error: Service Unavailable for url: https://database_url...

Инициализация моего слушателя заключена в операторе try, поэтому я не уверен, почему это не было поймано, проглочено и повторено, как я ожидал:

def init_listener():
    try:        
        listener = firebase_admin.db.reference(db_path).listen(handle_change)

    except Exception as e:
        time.sleep(1)  # Retry in one second.
        init_listener()

Я хотел бы обрабатывать будущие ошибки 503, но я не уверен, как это сделать.

Кроме того, я использую except Exception as e выше для целей демонстрации/отладки, но я также не уверен, будет ли requests.exceptions.HTTPError достаточно точным, чтобы отловить только 500 ошибок (хотя я не знаю, какие другие ошибки могут быть вызваны).

Анализ настроения постов в Twitter с помощью Python, Tweepy и Flair
Анализ настроения постов в Twitter с помощью Python, Tweepy и Flair
Анализ настроения текстовых сообщений может быть настолько сложным или простым, насколько вы его сделаете. Как и в любом ML-проекте, вы можете выбрать...
7 лайфхаков для начинающих Python-программистов
7 лайфхаков для начинающих Python-программистов
В этой статье мы расскажем о хитростях и советах по Python, которые должны быть известны разработчику Python.
Установка Apache Cassandra на Mac OS
Установка Apache Cassandra на Mac OS
Это краткое руководство по установке Apache Cassandra.
Сертификатная программа "Кванты Python": Бэктестер ансамблевых методов на основе ООП
Сертификатная программа "Кванты Python": Бэктестер ансамблевых методов на основе ООП
В одном из недавних постов я рассказал о том, как я использую навыки количественных исследований, которые я совершенствую в рамках программы TPQ...
Создание персонального файлового хранилища
Создание персонального файлового хранилища
Вы когда-нибудь хотели поделиться с кем-то файлом, но он содержал конфиденциальную информацию? Многие думают, что электронная почта безопасна, но это...
Создание приборной панели для анализа данных на GCP - часть I
Создание приборной панели для анализа данных на GCP - часть I
Недавно я столкнулся с интересной бизнес-задачей - визуализацией сбоев в цепочке поставок лекарств, которую могут просматривать врачи и...
1
0
280
1
Перейти к ответу Данный вопрос помечен как решенный

Ответы 1

Ответ принят как подходящий

Из справочные документы firebase_admin:

This API is based on the event streaming support available in the Firebase REST API. Each call to listen() starts a new HTTP connection and a background thread. This is an experimental feature.

Ключевым моментом здесь является то, что все это выполняется в фоновом потоке. Следовательно, обертывание вызова listen() в try/except не будет перехватывать исключения, созданные в потоке. Нет простого способа поймать исключения, происходящие в фоновом потоке.

Чтобы решить вашу проблему, вам, вероятно, потребуется больше узнать о том, почему база данных возвращает статус HTTP 503. Или вам нужно будет переключиться на какой-то другой firebase_admin API, который позволит вам перехватывать и игнорировать эти исключения.

Это имеет смысл, спасибо. Я планирую перейти на Firestore в надежде, что у него не будет таких же проблем с надежностью.

charliesneath 24.05.2019 02:23

Другие вопросы по теме